from tkinter import *
import random
import time

class Spiel:
    def __init__(self):
        self.tk = Tk()
        self.tk.title("Mr. Stick Man Races for the Exit")
        self.tk.resizable(0, 0)
        self.tk.wm_attributes("-topmost", 1)
        self.canvas = Canvas(self.tk, width=500, height=500, highlightthickness=0)
        self.canvas.pack()
        self.tk.update()
        self.canvas_height = 500
        self.canvas_width = 500
        self.bg = PhotoImage(file="Hintergrund.gif")
        w = self.bg.width()
        h = self.bg.height()
        for x in range(0, 5):
            for y in range(0, 5):
                self.canvas.create_image(x * w, y * h, image=self.bg, anchor='nw')
        self.sprites = []
        self.rennen = True

    def Hauptschleife(self):
        while 1:
            if self.rennen == True:
                for sprite in self.sprites:
                    sprite.move()
                self.tk.update_idletasks()
                self.tk.update()
                time.sleep(0.01)

class Koordinaten:
    def __init__(self, x1=0, y1=0, x2=0, y2=0):
        self.x1 = x1
        self.y1 = y1
        self.x2 = x2
        self.y2 = y2

def innerhalb_x(co1, co2):
    if (co1.x1 > co2.x1 and co1.x1 < co2.x2) \
            or (co1.x2 > co2.x1 and co1.x2 < co2.x2) \
            or (co2.x1 > co1.x1 and co2.x1 < co1.x2) \
            or (co2.x2 > co1.x1 and co2.x2 < co1.x1):
        return True
    else:
        return False

def innerhalb_y(co1, co2):
    if (co1.y1 > co2.y1 and co1.y1 < co2.y2) \
            or (co1.y2 > co2.y1 and co1.y2 < co2.y2) \
            or (co2.y1 > co1.y1 and co2.y1 < co1.y2) \
            or (co2.y2 > co1.y1 and co2.y2 < co1.y1):
        return True
    else:
        return False

def angestoßen_links(co1, co2):
    if innerhalb_y(co1, co2):
        if co1.x1 <= co2.x2 and co1.x1 >= co2.x1:
            return True
    return False

def angestoßen_rechts(co1, co2):
    if innerhalb_y(co1, co2):
        if co1.x2 >= co2.x1 and co1.x2 <= co2.x2:
            return True
    return False

def angestoßen_oben(co1, co2):
    if innerhalb_x(co1, co2):
        if co1.y1 <= co2.y2 and co1.y1 >= co2.y1:
             return True
    return False

def angestoßen_unten(y, co1, co2):
    if innerhalb_x(co1, co2):
        y_calc = co1.y2 + y
        if y_calc >= co2.y1 and y_calc <= co2.y2:
            return True
    return False

class Sprite:
    def __init__(self, spiel):
        self.spiel = spiel
        self.spielende = False
        self.koordinaten = None
    def move(self):
        pass
    def coords(self):
        return self.koordinaten

class EbenenSprite(Sprite):
    def __init__(self, spiel, photo_image, x, y, width, height):
        Sprite.__init__(self, spiel)
        self.photo_image = photo_image
        self.bild = spiel.canvas.create_image(x, y, image=self.photo_image, anchor='nw')
        self.koordinaten = Koordinaten(x, y, x + width, y + height)

s = Spiel()
Ebene1 = EbenenSprite(s, PhotoImage(file="Ebene1.gif"), 0, 480, 100, 10)
s.sprites.append(Ebene1)
s.Hauptschleife()
